// pbarpHeliLh class definition file. -*- C++ -*-
// Copyright 2012 Bertram Kopf

#pragma once

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <complex>
#include <boost/shared_ptr.hpp>
#include <boost/function.hpp>

#include "qft++/topincludes/relativistic-quantum-mechanics.hh"

#include "pbarpUtils/pbarpBaseLh.hh"
#include "PwaUtils/DataUtils.hh"
#include "Minuit2/MnUserParameters.h"

class AbsXdecAmp;
class pbarpReaction;
class HeliDecAmps;

class pbarpHeliLh : public pbarpBaseLh {

public:
  pbarpHeliLh(boost::shared_ptr<const EvtDataBaseList>);
  
  virtual ~pbarpHeliLh();
  
  virtual AbsLh* clone_() const {
    return new  pbarpHeliLh(_evtListPtr);
  }
  virtual void print(std::ostream& os) const;
  
protected:

  
private:
  
  void initialize();
  
};
